; Jungle Hit example by Balrog Software

; Declare varibles used on the game.
Declare hScreen.l, EventID.l, Quit.b, DC.l, fps.l, fpsfinal.l
Declare Zone.b, CloudAngle.f, Speed.b, Points.l, Lifes.b, Room.b
Declare ScoreRoom.b, Level.b, AnimalCounter.w, Info.b, PauseMusic.b

; This procedure show a text with shadow.
Procedure TextShadow(TDC.l, TX.l, TY.l, Text.s, Color.l)
  Text(TDC, TX+1, TY+1, Text, 0)
  Text(TDC, TX, TY, Text, Color)
EndProcedure()

; Declare arrays with information about clouds and animals.
Dim CloudX.w(3)
Dim CloudY.w(3)
Dim CloudZone.w(3)
Dim CloudPower.w(3)
Dim CloudAnimalY.w(3)
Dim CloudAnimalAction.b(3)
Dim CloudAnimal.b(3)
Dim CloudTouched.b(3)

; Some user constants.
#MOTION_PERCENT     =   3

#START_ROOM         =   0
#GAMEOVER_ROOM      =   1
#GAME_ROOM          =   2

#NO_MOVE            =   0
#MOVE_UP            =   1
#MOVE_DOWN          =   2

#ANIMAL_SHEEP       =   0
#ANIMAL_LION        =   1

#CLOUD_WIDTH        = 128
#CLOUD_HEIGHT       =  57
  
#FPS_TIMER          =   0
#ANGLE_TIMER        =   1
#ANIMAL_TIMER       =   2
#ROOM_TIMER         =   3
#INFO_TIMER         =   4
#ZONE_TIMER         =   5

Lifes = 3 : Points = 0 : Speed = 3 : Room = #START_ROOM : ScoreRoom = #True : Level = 1

CloudX(0) = 50 : CloudY(0) = 80
CloudX(1) = 50 : CloudY(1) = 330
CloudX(2) = 462 : CloudY(2) = 80
CloudX(3) = 462 : CloudY(3) = 330

If InitDXSprite() != 0

  hScreen = OpenDXScreen(640, 480, 16, "Jungle Hit")
  
  If hScreen != 0 
    SetVideoMode(#VMB_WEBCAM_VIDEOSTREAM)
    SetMotionDetection(#True, 24)
    SetDetectionPrecision(#VMB_WEBCAM_HALFPRECISION)
  
    InitWebcam(hScreen)
    
    WebcamRequester()
    
    SetAreaSize(640, 480)

    LoadDXSprite(1, "Gfx\Clouds.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(2, "Gfx\sheep.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(3, "Gfx\lion.bmp", #VMB_SPRITE_NORMAL)

    LoadWav(1, "Sound\Sheep.wav")
    LoadWav(2, "Sound\Lion.wav")
    LoadWav(3, "Sound\Karate.wav")
    LoadWav(4, "Sound\Clapping.wav")

    LoadMidi(1, "Sound\Music.mid")
    PlayMidi(1)

    HideCursor(#True)

    StartTimer(#FPS_TIMER) : StartTimer(#ANGLE_TIMER) : StartTimer(#ANIMAL_TIMER) : StartTimer(#ROOM_TIMER) : StartTimer(#INFO_TIMER)
    
    Repeat
      
      ProcessEvent()
      
      If KeyPushed(#VMB_KEY_ESCAPE) = #True
        Quit = #True
      EndIf

      If KeyPushed(#VMB_KEY_F1) = #True And GetTimer(#INFO_TIMER) > 150
        If Info = #True
          Info = #False
        Else
          Info = #True
        EndIf
        StartTimer(#INFO_TIMER)
      EndIf
 
      If IsScreenActive(hScreen) = #True

        If IsMidiPlaying(1) = #False
          PlayMidiFrom(1, 0)
          PauseMusic = #False
        EndIf        
        
        If GetTimer(#FPS_TIMER) >= 1000
          fpsfinal = fps : fps = 0
          StartTimer(#FPS_TIMER)
          For Zone = 0 To 3
            If CloudPower(Zone) != 0
              CloudPower(Zone) = CloudPower(Zone) - 2
              If CloudPower(Zone) < 0 : CloudPower(Zone) = 0 : EndIf
            EndIf
          Next
        EndIf
        
        If GetTimer(#ANGLE_TIMER) > 10
          Add(CloudAngle, 0.2)
          If CloudAngle > 6.283185 : CloudAngle = CloudAngle - 6.283185 : EndIf
          StartTimer(#ANGLE_TIMER)
        EndIf

        If Room = #GAMEOVER_ROOM And GetTimer(#ROOM_TIMER) > 1000
          ScoreRoom = #True
        EndIf

        If Room = #GAME_ROOM And AnimalCounter > 20 * Level
          AnimalCounter = 0
          Level = Level + 1
          If Level = 4 : Level = 1 : EndIf
          Speed = 4 - Level
        EndIf

        For Zone = 0 To 3
          CloudZone(Zone) = CheckMotionZone(CloudX(Zone), CloudY(Zone), 128, 57)  
          
          If GetTimer(#ZONE_TIMER+Zone) > 8 * Speed And Room = #GAME_ROOM
            If CloudAnimalAction(Zone) = #MOVE_UP
              CloudAnimalY(Zone) = CloudAnimalY(Zone) + 1
            EndIf
            If CloudAnimalAction(Zone) = #MOVE_DOWN
              CloudAnimalY(Zone) = CloudAnimalY(Zone) - 1
            EndIf
            If CloudAnimalAction(Zone) = #MOVE_UP And CloudAnimalY(Zone) >= 48
              CloudAnimalAction(Zone) = #MOVE_DOWN
              If CloudAnimal(Zone) = #ANIMAL_SHEEP
                PlayWav(1)
              Else
                PlayWav(2)
              EndIf
            EndIf
            If CloudAnimalAction(Zone) = #MOVE_DOWN And CloudAnimalY(Zone) <= 0
              CloudTouched(Zone) = #False
              CloudAnimalAction(Zone) = #NO_MOVE
            EndIf
            StartTimer(#ZONE_TIMER + Zone)
          EndIf
          
          If CloudZone(Zone) > #MOTION_PERCENT And ((ScoreRoom = #True And Room = #GAMEOVER_ROOM) Or Room != #GAMEOVER_ROOM)
            If Room = #GAME_ROOM
              If CloudTouched(Zone) = #False And CloudAnimalAction(Zone) != #NO_MOVE 
                If CloudAnimal(Zone) = #ANIMAL_SHEEP
                  Lifes = Lifes - 1
                  If Lifes <= 0 : Room = #GAMEOVER_ROOM : Lifes = 0 : ScoreRoom = #False : PlayWav(4) : StartTimer(#ROOM_TIMER) : EndIf
                Else
                  If CloudAnimalAction(Zone) = #MOVE_UP
                    Points = Points + (50 * Level)
                  Else
                    Points = Points + (25 * Level)
                  EndIf
                EndIf
              EndIf
              If CloudAnimalAction(Zone) != #NO_MOVE
                If CloudTouched(Zone) = #False 
                  PlayWav(3)
                  If CloudAnimal(Zone) = #ANIMAL_LION
                    PlayWav(2)
                  Else
                    PlayWav(1)
                  EndIf
                EndIf
                CloudTouched(Zone) = #True
                CloudAnimalAction(Zone) = #MOVE_DOWN
              EndIf
            Else 
              Level = 1 : Speed = 3 : Points = 2 : Lifes = 3 : Room = #GAME_ROOM
              StartTimer(#ANIMAL_TIMER)
            EndIf
            If CloudPower(Zone) > 0
              CloudPower(Zone) = (CloudPower(Zone) + (CloudZone(Zone) / 2)) / 2
            Else
              CloudPower(Zone) = CloudZone(Zone) / 2
            EndIf
            If CloudPower(Zone) < 6 : CloudPower(Zone) = 6 : EndIf
            If CloudPower(Zone) > 12 : CloudPower(Zone) = 12 : EndIf
          EndIf
        Next
        
        If GetTimer(#ANIMAL_TIMER) > 1500 * Speed And Room = #GAME_ROOM
          For Zone = 0 To 3
            If Random(1) = 1 And CloudAnimalAction(Zone) = #NO_MOVE
              CloudAnimalAction(Zone) = #MOVE_UP
              CloudAnimal(Zone) = Random(1)
              AnimalCounter = AnimalCounter + 1
            EndIf
          Next
          StartTimer(#ANIMAL_TIMER)
        EndIf
        
        Add(fps, 1)
        
        DC=GetDXScreenDC()
        DrawWebcamImage(DC, 0, 0, 640, 480)
        If Room = #GAME_ROOM
          TextShadow(DC,10,10,Add("Points: ", Str(Points)), RGB(255, 255, 255))
          TextShadow(DC,582,10,Add("Lifes: ", Str(Lifes)), RGB(255, 255, 255))
          TextShadow(DC,285,10,Add("Level ", Str(Level)), RGB(255, 64, 64))
          If Info = #True : Text(DC, 10, 30, Add(Str(fpsfinal), " FPS"), RGB(0, 0, 255)) : EndIf
        EndIf
        If Room = #START_ROOM
          TextShadow(DC, 285, 214, "Jungle Hit", RGB(64, 255, 64))
          TextShadow(DC, 250, 244, "Hit any cloud to start", RGB(64, 64, 255))
        EndIf
        If Room = #GAMEOVER_ROOM
          TextShadow(DC, 220, 214, "Game Over, hit a cloud to start.", RGB(64, 255, 64))
          TextShadow(DC, 320 - (StringLength(Add(Str(Points), " points.")) * 7 / 2), 250, Add(Str(Points), " points."), RGB(255, 64, 64))
        EndIf
        ReleaseDXScreenDC(DC)
        
        For Zone = 0 To 3
          If CloudAnimalAction(Zone) != #NO_MOVE And Room = #GAME_ROOM
            DrawDXTransparentSprite(CloudAnimal(Zone) + 2, CloudX(Zone) + 37, CloudY(Zone) - 2 - CloudAnimalY(Zone), 54, 54)
          EndIf
          DrawDXTransparentSprite(1, CloudX(Zone) - (CloudPower(Zone) * Cos(CloudAngle)), CloudY(Zone) - (CloudPower(Zone) * Sin(CloudAngle)), #CLOUD_WIDTH + (CloudPower(Zone) * Cos(CloudAngle) * 2), #CLOUD_HEIGHT + (CloudPower(Zone) * Sin(CloudAngle) * 2))
        Next 
        
        FlipDXBuffers(#VMB_SCREEN_CLEAR, RGB(0, 0, 0))

      Else
        Sleep(10)
        If PauseMusic = #False
          StopMidi(1)
          PauseMusic = #True
        EndIf
      EndIf
      
    Until Quit = #True
    
    FreeWebcam()
    
    FreeTimer(#FPS_TIMER) : FreeTimer(#ANGLE_TIMER) : FreeTimer(#ANIMAL_TIMER) : FreeTimer(#ROOM_TIMER) : FreeTimer(#INFO_TIMER)
    
    CloseWav(1) : CloseWav(2) : CloseWav(3) : CloseWav(4) : CloseMidi(1)

    HideCursor(#False)
    
    CloseDXScreen()
    
  EndIf
  
Else
  MessageRequester("Error", "Can't initialise DirectX 7.0 or higher.", #VMB_MESSAGEREQUESTER_OK)
EndIf

EndProgram