; VMM Basic Example by Balrog Software
; OpenGL example

Declare theta.f, hdc.l, WindowX.l, WindowY.l, WindowWidth.l, WindowHeight.l, hWnd.l, Quit.b
Declare Event.l, hMem.l, pixformat.l, hrc.l, Flags.l, Filter.l, ImageData.l

Dim Tex.l(3)

theta = 5.0

#GL_DEPTH_BUFFER_BIT       = 256
#GL_COLOR_BUFFER_BIT       = 16384
#GL_MODELVIEW              = 5888
#GL_TRIANGLES              = 4
#GL_TEXTURE_2D             = $0DE1
#GL_TEXTURE_MAG_FILTER     = $2800
#GL_TEXTURE_MIN_FILTER     = $2801
#GL_NEAREST                = $2600
#GL_LINEAR                 = $2601
#GL_LINEAR_MIPMAP_NEAREST  = $2701
#GL_BGR_EXT                = $80E0
#GL_UNSIGNED_BYTE          = $1401

#PFD_MAIN_PLANE = 0
#PIXEL_FORMAT_FLAGS = 37

Procedure DrawTriangle(prochdc.l)
  glLoadIdentity()
  glPushMatrix()
  glMatrixMode(#GL_MODELVIEW)
  glRotatef(theta, 0.0, 0.0, 1.0)
  glRotatef(theta, 1.0, 0.0, 0.0)  
  glRotatef(theta, 0.0, 1.0, 0.0) 
  glRotatef(theta, 0.0, 0.0, 1.0)
  glClearColor(0.0, 0.0, 1.0, 1.0)
  glClear(FnOr(#GL_COLOR_BUFFER_BIT, #GL_DEPTH_BUFFER_BIT))
  ;Draw
  
  glBegin(#GL_TRIANGLES)
  ;Now we set the texturecoordinates and the vertices.
  ;There is the same rule as it is in  glColor:
  ;The following vertices gets the texturecoordinates
  glTexCoord2f(0.0, 1.0)
  glVertex3f(-0.5 , 0.5 , 0)
  glTexCoord2f(1.0, 1.0)
  glVertex3f(0.5, 0.5 , 0)
  glTexCoord2f(0.5, 0.0)
  glVertex3f(0.0 , -0.5, 0.0)
  glEnd()
  
  theta=Add(theta, 0.5)
  
  glPopMatrix()
  glFinish()
  
  SwapBuffers(prochdc)
EndProcedure()

Procedure LoadGLTexture(Filename.s)
  Local hFile.l, FileSize.l, ret.l, Width.l, Height.l, lpFSHigh.l
  
  If FileRead(1, Filename)!=0
    FileSize=FileSize(1)
    ImageData = AllocateMemory(2, FileSize)
    ReadData(1, ImageData, FileSize)
    FileClose(1)
  EndIf

  Width = PeekL(ImageData + $12)
  Height = PeekL(ImageData + $16)

  glGenTextures(3, AddressOf(Tex(0)))

  ;we choose 3 filters for our texture
  glBindTexture(#GL_TEXTURE_2D, AddressOf(Tex(0)))
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MAG_FILTER, #GL_NEAREST)
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MIN_FILTER, #GL_NEAREST)
  glTexImage2D(#GL_TEXTURE_2D, 0, 3, Width, Height, 0, #GL_BGR_EXT, #GL_UNSIGNED_BYTE, ImageData + PeekL(ImageData + 10))
  
  glBindTexture(#GL_TEXTURE_2D, AddressOf(Tex(1)))
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MAG_FILTER, #GL_LINEAR)
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MIN_FILTER, #GL_LINEAR)
  glTexImage2D(#GL_TEXTURE_2D, 0, 3, Width, Height, 0, #GL_BGR_EXT, #GL_UNSIGNED_BYTE, ImageData + PeekL(ImageData + 10))
  
  glBindTexture(#GL_TEXTURE_2D, AddressOf(Tex(2)))
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MAG_FILTER, #GL_LINEAR)
  glTexParameteri(#GL_TEXTURE_2D, #GL_TEXTURE_MIN_FILTER, #GL_LINEAR_MIPMAP_NEAREST)
  gluBuild2DMipmaps(#GL_TEXTURE_2D, 3, Width, Height, #GL_BGR_EXT, #GL_UNSIGNED_BYTE, ImageData + PeekL(ImageData + 10))
  
EndProcedure()

Procedure HandleError(Result.l, Text.l)
  If Result=0
    MessageBox(0, Text, "OpenGL Error", 0)
    EndProgram
  EndIf
EndProcedure()

Procedure SetPFD()
  hMem=AllocateMemory(1, 40)
  If hMem!=0
    PokeW(UseMemory(1), 40)
    PokeW(UseMemory(1) + 2, 1)
    PokeL(UseMemory(1) + 4, #PIXEL_FORMAT_FLAGS)
    PokeB(UseMemory(1) + 9, 16)
    PokeB(UseMemory(1) + 23, 16)
  EndIf
EndProcedure(hMem)

WindowWidth=640 + (GetSystemMetrics(#SM_CXBORDER) * 2)
WindowHeight=480 + ((GetSystemMetrics(#SM_CYBORDER) * 2) + GetSystemMetrics(#SM_CYCAPTION))

WindowX=(GetSystemMetrics(#SM_CXSCREEN) / 2) - (WindowWidth / 2)
WindowY=(GetSystemMetrics(#SM_CYSCREEN) / 2) - (WindowHeight / 2)

hWnd=WindowCreate("VMBasic And OpenGL", WindowX, WindowY, WindowWidth, WindowHeight, FnOr(FnOr(#WS_VISIBLE,#WS_BORDER),#WS_SYSMENU))

If hWnd!=0 And SetPFD()!=0
  
  hdc=GetDC(hWnd)
  
  pixformat=ChoosePixelFormat(hdc, hMem)
  
  HandleError(SetPixelFormat(hdc, pixformat, hMem), "SetPixelFormat()")
  
  hrc=wglCreateContext(hdc)
  
  HandleError(wglMakeCurrent(hdc,hrc), "wglMakeCurrent()")
  HandleError(glViewport (0, 0, WindowWidth - 30, WindowHeight - 30), "GLViewPort()") 
 
  glClearColor(0.0, 0.0, 1.0, 1.0)
  
  LoadGLTexture("Gfx\lion.bmp")

  filter=1
  glBindTexture(#GL_TEXTURE_2D, AddressOf(Tex(filter)))
  glEnable(#GL_TEXTURE_2D)
  
  While Quit=0
    
    ProcessEvent()
    
    Event=MessageID()
    
    If Event=#WM_CLOSE 
      Quit=1
    EndIf
    
    DrawTriangle(hdc)
    
  Wend

  If hMem!=0 : FreeMemory(1): EndIf
  If ImageData!=0 : FreeMemory(2) : EndIf
  
EndIf

EndProgram