; CopyRight 2004 - VMM Basic Fighters - by Balrog Software
; Game example with anims, collisions and a background scroll.
; The first game of VMM Basic!!! 

Declare hScreen.l, EventID.l, Quit.b, DC.l, XPlayer.l, YPlayer.l, sht.b, fired.b
Declare FireKeyTimer.l, InmunityTimer.l, BackX.l, BackY.l, Points.l, Lifes.b, Vel.l
Declare ScrollY.b, enemy.b, KeyPushed.b, SpriteChange.b, InmunityFlip.b, Inmunity.b
Declare PauseMusic.b, PlayerExplosion.b, PlayerExplosionX.l, PlayerExplosionY.l, Angle.f

; Set start player position

XPlayer = 320 : YPlayer = 440

; Constants for max number of enemies and shots

#MAX_SHOTS                   =    4
#MAX_ENEMIES                 =   12

; This constants have the time in milliseconds that waits to read again the keyboard

#CURSOR_KEYS_RESPONSE_TIME   =   10
#SPACE_KEY_RESPONSE_TIME     =  128

#NUMBER_OF_ANIMS             =    3

; Declare arrays for handle of animations, shots position 
; and state, and enemy position, and animations

Dim FiredShot.l(#MAX_SHOTS)
Dim ShotX.l(#MAX_SHOTS)
Dim ShotY.l(#MAX_SHOTS)

Dim EnemyX.l(#MAX_ENEMIES)
Dim EnemyY.l(#MAX_ENEMIES)
Dim EnemyVel.l(#MAX_ENEMIES)

; This animations are for enemies explosions

Dim AnimExplosionX.l(#MAX_ENEMIES)
Dim AnimExplosionY.l(#MAX_ENEMIES)
Dim AnimExplosionState.b(#MAX_ENEMIES)
Dim AnimExplosionTimer.l(#MAX_ENEMIES)
Dim AnimExplosionTempo.l(#MAX_ENEMIES)
Dim AnimExplosionActualFrame.b(#MAX_ENEMIES)
Dim AnimExplosionFrames.b(#MAX_ENEMIES)

; This animations are for player ship and explosions, and enemies ships

Dim Anim.l(#NUMBER_OF_ANIMS,3)
Dim AnimTimer.l(#NUMBER_OF_ANIMS)
Dim AnimTempo.l(#NUMBER_OF_ANIMS)
Dim AnimActualFrame.b(#NUMBER_OF_ANIMS)
Dim AnimFrames.b(#NUMBER_OF_ANIMS)

; This procedure swap the background sprites to have this effect:
; * * * * * *
;  * * * * * 
; * * * * * *
; if this procedure is not executed the background will show like this:
; * * * * * *
; * * * * * *
; * * * * * *

Procedure SwapBackSprites()
  If SpriteChange = 2 : SpriteChange = 1 : Else : SpriteChange = 2 : EndIf
EndProcedure()

Procedure UpdateAnimations()
  Local AnimNb.l
  For AnimNb = 0 To #NUMBER_OF_ANIMS
    If AnimNb != 2 Or (PlayerExplosion = #True And AnimNb = 2)
      If GetTickCount() - AnimTimer(AnimNb) > AnimTempo(AnimNb) 
        AnimActualFrame(AnimNb) = AnimActualFrame(AnimNb) + 1
        If AnimActualFrame(AnimNb) = AnimFrames(AnimNb) : AnimActualFrame(AnimNb) = 0 : If AnimNb = 2 : PlayerExplosion = #False : EndIf : EndIf
        AnimTimer(AnimNb) = GetTickCount() 
      EndIf
    EndIf
  Next
EndProcedure()

Procedure UpdateAnimExplosionations()
  Local AnimNb.l
  For AnimNb = 0 To #MAX_ENEMIES
    If AnimExplosionState(AnimNb) = #True
      If GetTickCount() - AnimExplosionTimer(AnimNb) > AnimExplosionTempo(AnimNb) 
        AnimExplosionActualFrame(AnimNb) = AnimExplosionActualFrame(AnimNb) + 1
        If AnimExplosionActualFrame(AnimNb) >= AnimExplosionFrames(AnimNb) : AnimExplosionState(AnimNb) = #False : EndIf
        AnimExplosionTimer(AnimNb) = GetTickCount() 
      EndIf
    EndIf
  Next
EndProcedure()

Procedure InitialiseExplosion(EnemyNumber.l)
  AnimExplosionState(EnemyNumber) = #True
  AnimExplosionX(EnemyNumber) = EnemyX(EnemyNumber) + (4 * Cos(Angle))
  AnimExplosionY(EnemyNumber) = EnemyY(EnemyNumber)
  AnimExplosionTempo(EnemyNumber) = 120
  AnimExplosionFrames(EnemyNumber) = 4
  AnimExplosionTimer(EnemyNumber) = GetTickCount()
  AnimExplosionActualFrame(EnemyNumber) = 0
EndProcedure()

Procedure InitialiseEnemy(EnemyNumber.l)
  EnemyX(EnemyNumber) = Random(640)
  EnemyVel(EnemyNumber) = Random(1) + 2
  EnemyY(EnemyNumber) = -34
EndProcedure()

; Initialise DirectX for sprites drawing

If InitDXSprite() = #True
  
  ; Load the midi music
  
  LoadMidi(1, "sound\skndegg1[1].mid")
   
  ; Create a screen of 640x480 and 16 bits of color 
  
  hScreen = OpenDXScreen(640, 480, 16, "VMM Fighters Fighters") 

  If hScreen != #False
    
    ; Load sprites and save its handle
    
    LoadDXSprite(0, "gfx\shot.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(1, "gfx\back1.bmp", #VMB_SPRITE_NORMAL)
    LoadDXSprite(2, "gfx\back2.bmp", #VMB_SPRITE_NORMAL)
    
    ; Create sprite animations
    ; AnimTempo is the millisecs for every frame
    ; AnimTimer have the timer counter updated when the frame its updated
    ; AnimFrames have totally number of frames
    
    Anim(0,0) = LoadDXSprite(3, "gfx\ship1.bmp", #VMB_SPRITE_NORMAL)
    Anim(0,1) = LoadDXSprite(4, "gfx\ship2.bmp", #VMB_SPRITE_NORMAL)
    Anim(0,2) = LoadDXSprite(5, "gfx\ship3.bmp", #VMB_SPRITE_NORMAL)
    AnimTempo(0) = 80
    AnimTimer(0) = GetTickCount()
    AnimFrames(0) = 3
    
    Anim(1,0) = LoadDXSprite(6, "gfx\enemy1.bmp", #VMB_SPRITE_NORMAL)
    Anim(1,1) = LoadDXSprite(7, "gfx\enemy2.bmp", #VMB_SPRITE_NORMAL)
    Anim(1,2) = LoadDXSprite(8, "gfx\enemy3.bmp", #VMB_SPRITE_NORMAL)
    AnimTempo(1) = 70
    AnimTimer(1) = GetTickCount()
    AnimFrames(1) = 3
    
    Anim(2,0) = LoadDXSprite(9, "gfx\explode1.bmp", #VMB_SPRITE_NORMAL)
    Anim(2,1) = LoadDXSprite(10, "gfx\explode2.bmp", #VMB_SPRITE_NORMAL)
    Anim(2,2) = LoadDXSprite(11, "gfx\explode3.bmp", #VMB_SPRITE_NORMAL)
    Anim(2,3) = LoadDXSprite(12, "gfx\explode4.bmp", #VMB_SPRITE_NORMAL)
    AnimTempo(2) = 150
    AnimTimer(2) = GetTickCount()
    AnimFrames(2) = 4
    
    ; Initialise enemies variables
    
    For enemy = 0 To #MAX_ENEMIES
      InitialiseEnemy(enemy)
    Next
    
    ; Load wav files

    LoadWav(1, "Sound\blaster.wav")
    LoadWav(2, "Sound\explosion.wav")

    ; Hide the cursor
    
    HideCursor(#True)
    
    ; Play the music
    
    PlayMidi(1)
    
    SpriteChange = 1
   
    FireKeyTimer = GetTickCount()
    InmunityTimer = GetTickCount()

    Lifes = 3

    StartTimer(1)

    Repeat
      
      ; Process event for games, dont use WaitEvent for games
      
      ProcessEvent()
      
      EventID = MessageID()
      
      ; If user press Alt+F4 or press escape key, exit from program
      
      If EventID = #WM_CLOSE Or GetAsyncKeyState(#VK_ESCAPE) = -32767
        Quit = #True
        CloseMidi(1)
      EndIf
      
      ; Test if our window have the focus, and our game dont was minimized
      
      If IsScreenActive(hScreen) = #True
        
        If IsMidiPlaying(1) = #False
          PlayMidiFrom(1, 0)
          PauseMusic = #False
        EndIf
        
        ; Read cursor keys to modify the ship velocity
        
        KeyPushed = #False
        
        If GetKeyState(#VK_LEFT) < 0 And GetTimer(1) > #CURSOR_KEYS_RESPONSE_TIME
          XPlayer = XPlayer - 2
          KeyPushed = #True
        EndIf
        If GetKeyState(#VK_RIGHT) < 0 And GetTimer(1) > #CURSOR_KEYS_RESPONSE_TIME
          XPlayer = XPlayer + 2
          KeyPushed = #True
        EndIf
        If GetKeyState(#VK_UP) < 0 And GetTimer(1) > #CURSOR_KEYS_RESPONSE_TIME
          YPlayer = YPlayer - 2
          KeyPushed = #True
        EndIf
        If GetKeyState(#VK_DOWN) < 0 And GetTimer(1) > #CURSOR_KEYS_RESPONSE_TIME
          YPlayer = YPlayer + 2
          KeyPushed = #True
        EndIf
        
        ; If cursor keys are pressed, reset the CursorKeyTimer
        
        If KeyPushed = #True
          StartTimer(1)
        EndIf
        
        If XPlayer < 0 : XPlayer = 0 : EndIf 
        If XPlayer > 640 : XPlayer = 640 : EndIf
        If YPlayer < 32 : YPlayer = 32 : EndIf 
        If YPlayer > 450 : YPlayer = 450 : EndIf
        
        ; If player press space a shot is added to the game
        
        If KeyPushed(#VK_SPACE)=#True And GetTickCount() - FireKeyTimer > #SPACE_KEY_RESPONSE_TIME
          Sht = 0 : KeyPushed = #True : fired = #False
          For Sht = 0 To #MAX_SHOTS
            If FiredShot(Sht) = #False And fired = #False
              Fired = #True
              ShotY(Sht) = YPlayer - 26
              ShotX(Sht) = XPlayer
              FiredShot(Sht) = #True
              PlayWav(1)
            EndIf
          Next
          FireKeyTimer = GetTickCount()
        EndIf
        
        ; Draw the background tiles
        
        For BackY = -32 To 448 Step 32
          For BackX = 0 To 608 Step 32
            DrawDXSpriteFast(SpriteChange, BackX, BackY + ScrollY)
            SpriteChange = SpriteChange + 1 : If SpriteChange = 3 : SpriteChange = 1 : EndIf
          Next
          SwapBackSprites()
        Next
        ScrollY = ScrollY + 1 
        If ScrollY > 31 : ScrollY = 0 : SwapBackSprites() : EndIf
        
        ; Update animation timers and actual frame
        
        UpdateAnimations()
        
        UpdateAnimExplosionations()
        
        ; Draw the player ship
        
        If GetTickCount() - InmunityTimer < 3000 And Inmunity = #True
          InmunityFlip = InmunityFlip + 1
          If InmunityFlip > 9 : InmunityFlip = 0 : EndIf
          If InmunityFlip < 5 : DrawDXTransparentSpriteFast(Anim(0, AnimActualFrame(0)), XPlayer - 33, YPlayer - 26) : EndIf
        EndIf
        
        If GetTickCount() - InmunityTimer > 3000 And Inmunity = #True : Inmunity = #False : EndIf 
        
        If Inmunity = #False
          DrawDXTransparentSpriteFast(Anim(0, AnimActualFrame(0)), XPlayer - 33, YPlayer - 26) 
        EndIf
        
        ; Move and draw enemies ships
        
        Add(Angle, 0.1)
        If Angle >= 6.283185
          Angle = 0.0
        EndIf

        For enemy = 0 To #MAX_ENEMIES
          If EnemyY(enemy) > 514
            InitialiseEnemy(enemy)
          EndIf
          EnemyY(enemy) = EnemyY(enemy) + EnemyVel(enemy)
          DrawDXTransparentSpriteFast(Anim(1, AnimActualFrame(1)), EnemyX(enemy) - 21 + (4 * Cos(Angle)), EnemyY(enemy) - 17)
        Next
        
        ; Draw shots
        
        For Sht = 0 To #MAX_SHOTS
          If FiredShot(Sht) = #True
            ShotY(Sht) = ShotY(Sht) - 3
            DrawDXTransparentSpriteFast(0, ShotX(Sht) - 2, ShotY(Sht) - 4)
            
            If FiredShot(Sht) = #True And ShotY(Sht) < -8
              FiredShot(Sht) = #False
            EndIf
          EndIf
        Next
        
        ; Draw explosion sprites
        
        If PlayerExplosion = #True
          DrawDXTransparentSpriteFast(Anim(2, AnimActualFrame(2)), PlayerExplosionX - 14, PlayerExplosionY - 20)
          PlayerExplosionY = PlayerExplosionY + 1
        EndIf
        For enemy = 0 To #MAX_ENEMIES
          If AnimExplosionState(enemy) = #True
            DrawDXTransparentSpriteFast(Anim(2, AnimExplosionActualFrame(enemy)), AnimExplosionX(enemy) - 14, AnimExplosionY(enemy) - 20)
            AnimExplosionY(enemy) = AnimExplosionY(enemy) + 1
          EndIf 
        Next
        
        ; Check collisions between enemies ships and player ship and bullets
        
        For enemy = 0 To #MAX_ENEMIES
          For Sht = 0 To #MAX_SHOTS
            If FiredShot(Sht) = #True
              
              ; Check if a bullet hit an enemy ship
              
              If SpriteDXCollision(ShotX(Sht) - 2, ShotY(Sht) - 4, 5, 8, EnemyX(enemy) - 21 + (4 * Cos(Angle)), EnemyY(enemy) - 17, 42, 34) = #True
                
                InitialiseExplosion(enemy)
                
                InitialiseEnemy(enemy)
                
                FiredShot(Sht)=#False
                
                Points = Points + 10

                PlayWav(2)

              EndIf
            EndIf
          Next
          
          ; Check if a enemy ship hit the player ship
          
          If SpriteDXCollisionFast(3, XPlayer - 33, YPlayer - 26, 6, EnemyX(enemy) - 21 + (4 * Cos(Angle)), EnemyY(enemy) - 17) = #True And GetTickCount() - InmunityTimer > 3000
            
            ; Set inforation to draw player explosion
            
            PlayerExplosion = #True
            PlayerExplosionX = XPlayer
            PlayerExplosionY = YPlayer
            
            ; Reset player explosion animation 
            
            AnimActualFrame(2) = 0 
            AnimTimer(2) = GetTickCount()
            
            ; Reset enemy ship and its explosion
            
            InitialiseExplosion(enemy)
            
            InitialiseEnemy(enemy)
            
            PlayWav(2)

            XPlayer = 320
            YPlayer = 440

            Lifes = Lifes - 1
            If Lifes = 0 : Lifes = 3 : Points = 0 : EndIf

            InmunityTimer = GetTickCount()
            Inmunity = #True
          EndIf
        Next

        ; Show life number and points

        DC=GetDXScreenDC()

        Text(DC,10,10,Add("Points: ", Str(Points)), RGB(0,0,0))
        Text(DC,9,9,Add("Points: ", Str(Points)), RGB(255,255,255))
        Text(DC,583,10,Add("Lifes: ", Str(Lifes)), RGB(0,0,0))
        Text(DC,582,9,Add("Lifes: ", Str(Lifes)), RGB(255,255,255))
        
        ReleaseDXScreenDC(DC)

        ; Flipbuffers to show last drawings, and without clear the screen because
        ; we are drawing with sprites all the screen
        
        FlipDXBuffers(0, 0)
        
      Else
        
        Sleep(10)
        If PauseMusic = #False
          StopMidi(1)
          PauseMusic = #True
        EndIf
        
      EndIf
      
    Until Quit = #True
    
    ; Show mouse cursor
    HideCursor(#False)
    
    ; Close DirectX Screen and destroy the window
    CloseDXScreen()
    
  EndIf
Else
  MessageBox(0, "Can't initialise DirectX", "Error", 0)
EndIf

EndProgram