; VMM Basic Example by Balrog Software
; OpenGL example

Declare theta.f, hdc.l, WindowX.l, WindowY.l, WindowWidth.l, WindowHeight.l, hWnd.l, Quit.b
Declare Event.l, hMem.l, pixformat.l, hrc.l, Flags.l

theta = 5.0

#GL_DEPTH_BUFFER_BIT = 256
#GL_COLOR_BUFFER_BIT = 16384
#GL_MODELVIEW = 5888
#GL_TRIANGLES = 4

#PFD_MAIN_PLANE = 0
#PIXEL_FORMAT_FLAGS = 37

Procedure DrawTriangle(prochdc.l)
  glPushMatrix()
  glMatrixMode(#GL_MODELVIEW)
  glRotatef(theta, 0.0, 0.0, 1.0)
  glRotatef(theta, 1.0, 0.0, 0.0)  
  glRotatef(theta, 0.0, 1.0, 0.0) 
  glRotatef(theta, 0.0, 0.0, 1.0)
  glClearColor(0.0, 0.0, 0.0, 0.0)
  glClear(FnOr(#GL_COLOR_BUFFER_BIT,#GL_DEPTH_BUFFER_BIT))
  
  glBegin(#GL_TRIANGLES)
  glColor3f (1.0, 0.0, 0.0)
  glVertex2f(0.0, 1.0)
  glColor3f (0.0, 1.0, 0.0)
  glVertex2f(0.87, -0.5)
  glColor3f (0.0, 0.0, 1.0)
  glVertex2f(-0.87, -0.5)
  glEnd()
  
  theta=Add(theta, 0.5)
  
  glPopMatrix()
  glFinish()
  
  SwapBuffers(hdc)
EndProcedure()

Procedure HandleError(Result.l, Text.l)
  If Result=0
    MessageBox(0, Text, "OpenGL Error", #VMB_MESSAGEREQUESTER_OK)
    EndProgram
  EndIf
EndProcedure()

Procedure SetPFD()
  hMem=AllocateMemory(1, 40)
  If hMem!=0
    StackPointer(hMem)
    PushW(40)
    PushW(1)
    PushL(#PIXEL_FORMAT_FLAGS)
    PushB(16)
    StackPointer(hMem+23)
    PushB(16)
  EndIf
EndProcedure(hMem)

WindowWidth=320 + (GetSystemMetrics(#SM_CXBORDER) * 2)
WindowHeight=240 + ((GetSystemMetrics(#SM_CYBORDER) * 2) + GetSystemMetrics(#SM_CYCAPTION))

WindowX=(GetSystemMetrics(#SM_CXSCREEN)/2)-(WindowWidth/2)
WindowY=(GetSystemMetrics(#SM_CYSCREEN)/2)-(WindowHeight/2)

hWnd=OpenWindow(0, WindowX, WindowY, WindowWidth, WindowHeight,"VMM Basic And OpenGL", FnOr(FnOr(#VMB_WINDOW_VISIBLE,#VMB_WINDOW_BORDER),#VMB_WINDOW_SYSTEMMENU))

If hWnd!=0 And SetPFD()!=0
  
  hdc=GetDC(hWnd)
  
  pixformat=ChoosePixelFormat(hdc, hMem)
  
  HandleError(SetPixelFormat(hdc, pixformat, hMem), "SetPixelFormat()")
  
  hrc=wglCreateContext(hdc)
  
  HandleError(wglMakeCurrent(hdc,hrc), "wglMakeCurrent()")
  HandleError(glViewport (0, 0, Sub(WindowWidth,30), Sub(WindowHeight,30)), "GLViewPort()") 
  
  While Quit=0
    
    ProcessEvent()
    
    Event=MessageID()
    
    If Event=#VMB_EVENT_CLOSE 
      Quit=1
    EndIf
    
    DrawTriangle(hdc)

  Wend
  
  If hMem!=0 : FreeMemory(1) : EndIf
  
EndIf

EndProgram